#!/usr/bin/python
from subprocess import Popen, PIPE
from pylab import *
import os

ls_cmd='ls -1 OMP_NUM_THREADS=*.dat'
p = Popen(ls_cmd, shell=True, stdout=PIPE)
output, errors = p.communicate()

labels=[]
fig = figure()
markers=['o','s','D','*','+','^','v']
proc=''
for fname in output.split():
	f = open(fname,'r')
	print fname
	x = []
	y = []
	for line in f.readlines():
		if line[:13]=='# Processor: ': 
			proc = line[13:-1]; continue
		elif line[0]=='#': continue
		vls = line.split()
		x += [float(vls[1])]
		y += [float(vls[4])]
	plot(x,y,ls=':',marker=markers[0])
	markers = markers[1:]
	labels += [fname[fname.index('=')+1:fname.index('.')]]

title('YADE Perfomance Benchmark\n'+proc)

labels[0] = 'THREADS='+labels[0]
legend(labels,loc='best')
xlabel('Number of spheres')
ylabel('Perfomance, sec/iter')
grid(True)

output_base='perfomance-benchmark'
output_ext='.png'

output_file=output_base+output_ext
if os.path.exists(output_file):
	i=0; 
	while os.path.exists(output_base+'~%d'%i+output_ext): i+=1
	os.rename(output_file,output_base+'~%d'%i+output_ext)
savefig(output_file)
#show()
		
	
